sound_init
		pha
		lda	#$00
		tay
		ldx	#$ff
.loop
		sta	<$00,x
		dex
		bne	.loop

		ldx	#$ff
		stx	<ZERO_CH
.looploop
		sta	$0700,x
		sta	$0600,x
		dex
		bne	.looploop

		lda	#$0f
		sta	$4015			;܂ŉ

		pla
		asl	a
		tax
		lda	SONG_TBL,x		;ȔԍAhXe[u
		sta	<ZERO_00
		lda	SONG_TBL+1,x
		sta	<ZERO_01

		lda	[ZERO_00],y		;܂͓ǂݍ
		sta	<ZERO_02		;tO

sound_channel_set
		ldx	<ZERO_CH
		cpx	#$07			;̃gR
		beq	sound_channel_reset
		inc	<ZERO_CH
		ldx	<ZERO_CH
		lsr	<ZERO_02		;CtOɓ
		bcc	.ch_set			;C=0Ȃ

		inc	<ZERO_00
		bne	.throuth_00
		inc	<ZERO_01
.throuth_00

		lda	[ZERO_00],y
		sta	SND_ADD_L,x		;`lʃAhXZbg

		inc	<ZERO_00
		bne	.throuth_01
		inc	<ZERO_01
.throuth_01

		lda	[ZERO_00],y
		sta	SND_ADD_H,x		;`lʃAhXZbg
		jmp	sound_channel_set

.ch_set
		lda	#$80
		sta	EFC_FLAG,x		;
		jmp	sound_channel_set	;߂

;-------------------------------------------------------------------------------
sound_channel_reset				;init  play RRŌ
		lda	#$00
		sta	<ZERO_CH
		rts				;łI
;--------------------------
sound_driver_start
		ldx	<ZERO_CH
		cpx	#$08
		beq	sound_channel_reset

		lda	EFC_FLAG,x		;ŏǂ
		bmi	.main_end2		;chȂ炨I

.count_check
		lda	SND_COUNT,x
		bne	.rest_check

		lda	SND_ADD_L,x
		sta	<ZERO_00
		lda	SND_ADD_H,x
		sta	<ZERO_01		;[ɃAhX

		jsr	sound_data_read
		ldx	<ZERO_CH

		lda	<ZERO_00
		sta	SND_ADD_L,x
		lda	<ZERO_01
		sta	SND_ADD_H,x		;[AhX߂

.rest_check
		lda	EFC_FLAG,x
		and	#%01000000
		bne	.main_end		;xȂ炨Ƃ

 IFDEF	ES_DATA_TBL
.soft_enve_check
		lda	ES_VALUE,x
		beq	.duty_enve_check
		jsr	ES_SOUND
.duty_enve_check
 ENDIF

 IFDEF	ED_DATA_TBL
		lda	ED_VALUE,x
		beq	.note_enve_check
		jsr	ED_SOUND
.note_enve_check
 ENDIF

 IFDEF	EN_DATA_TBL
		lda	EN_VALUE,x
		beq	.pitch_enve_check
		jsr	EN_SOUND
.pitch_enve_check
 ENDIF

 IFDEF	EP_DATA_TBL
		lda	EP_VALUE,x
		beq	.reg_write
		jsr	EP_SOUND
.reg_write
 ENDIF

 IF (SOUND_GENERATOR)
		cpx	#$05
		bmi	.reg4000
		jsr	ex_apu_reg		;g͂炩
		jmp	.main_end
.reg4000
 ENDIF
		cpx	#$04			;DPCMȂX[
		beq	.main_end
		jsr	sound_register_write
.main_end
		dec	SND_COUNT,x
.main_end2
		inc	<ZERO_CH
		jmp	sound_driver_start
;---------------------------------------;R}h[h
sound_data_read
		jsr	sound_data_add
		bpl	.note_set		;f[^ۂ
		sta	<ZERO_02
		lda	#$ff
		sec
		sbc	<ZERO_02
		asl	a
		tay
		lda	JUMP_TBL,y
		sta	<ZERO_02
		lda	JUMP_TBL+1,y
		sta	<ZERO_03
		jmp	[ZERO_02]		;eR}hփWv
.note_set
		jsr	note_set_sub
		jmp	sound_effect_init
note_set_sub
		cpx	#$02
		beq	.triangle_set
		cpx	#$03
		beq	.noise_set
 IFDEF	dpcm_data
		cpx	#$04
		beq	.dpcm_set
 ENDIF

 IF (SOUND_GENERATOR)
		cpx	#$05
		bpl	.ex_apu_freq_set
 ENDIF
		sec
		sbc	#$15
		bpl	.pulse_set
.triangle_set
		sec
		sbc	#$09
		bpl	.pulse_set
.noise_set
		ldy	#$00		;?
		sty	$400f		;?
.pulse_set
		sta	SND_NOTE,x
		jsr	sound_data_add
		sta	SND_COUNT,x
		jmp	sound_freq_set

 IFDEF	dpcm_data
.dpcm_set
		asl	a
		asl	a
		tay
		pha
		lda	#$0f
		sta	$4015
		pla
		lda	DPCM_DATA,y		;DPCM control
		sta	$4010
		lda	DPCM_DATA+1,y		;DPCM wave control
		sta	$4011
		lda	DPCM_DATA+2,y		;DPCM address set
		sta	$4012
		lda	DPCM_DATA+3,y		;DPCM length set
		sta	$4013
		lda	#$1f
		sta	$4015
		jsr	sound_data_add
		sta	SND_COUNT,x
		rts
 ENDIF

 IF (SOUND_GENERATOR)
.ex_apu_freq_set
		jmp	ex_apu_freq
 ENDIF
;---------------------------------------;Wve[u
JUMP_TBL
		dw	data_end		;$ff
		dw	data_jump		;$fe
		dw	data_return		;$fd
		dw	rest_set		;$fc
		dw	tie                     ;$fb
		dw	slur                    ;$fa
		dw	frequncy_direct_write   ;$f9
		dw	memory_direct_write     ;$f8
		dw	volume_absolute_value 	;$f7
		dw	volume_relative_value	;$f6
		dw	volume_software_enverope;$f5
		dw	quantize                ;$f4
		dw	quantize_front          ;$f3
		dw	quantize_back           ;$f2
		dw	quantize_off            ;$f1
		dw	detune			;$f0
		dw	pitch_enverope          ;$ef
		dw	note_enverope           ;$ee
		dw	duty_change_2a03	;$ed
		dw	duty_enverope_2a03	;$ec
		dw	hardware_sweep_2a03	;$eb

;ȉ͗\				;Ƃ[`RsyĎg񂻂
;	dw	wave_change_2c33
;	dw	hardware_effect_2c33
;	dw	wave_set_n106
;	dw	wave_change_n106
;---------------------------------------;eR}h
sound_data_add
		inc	<ZERO_00
		bne	.through
		inc	<ZERO_01
.through
		ldy	#$00
		lda	[ZERO_00],y		;(Ԑ),y
		rts
;---------------------------------------;$fff[^Gh
data_end
		ldx	<ZERO_CH
		lda	#$80
		sta	EFC_FLAG,x		;`l
		cpx	#$04
		beq	.dpcm
		lda	#$00			;̏2A03pȂ̂Ȃ
		sta	SND_FREQ_L,x
		sta	SND_FREQ_H,x
		sta	A_VOLUME,x
		rts
.dpcm
		lda	#$0f
		sta	$4015
		rts
;---------------------------------------;$feWv
data_jump
		jsr	sound_data_add
		sta	<ZERO_02
		jsr	sound_data_add
		sta	<ZERO_03
		lda	<ZERO_00
		sta	RT_ADD_L,x
		lda	<ZERO_01
		sta	RT_ADD_H,x
		lda	<ZERO_02
		sta	<ZERO_00
		lda	<ZERO_03
		sta	<ZERO_01
		jmp	sound_data_read
;---------------------------------------;$fdWv^[
data_return
		lda	RT_ADD_L,x
		sta	<ZERO_00
		lda	RT_ADD_H,x
		sta	<ZERO_01
		jmp	sound_data_read
;---------------------------------------;$fc{[
volume_absolute_value
		jsr	sound_data_add
		sta	A_VOLUME,x
		lda	#$00
		sta	ES_VALUE,x
		sta	R_VOLUME,x
		jmp	sound_data_read
;---------------------------------------;΃{[
volume_relative_value
		jsr	sound_data_add
		clc
		adc	R_VOLUME,x
		sta	R_VOLUME,x
		jmp	sound_data_read
;---------------------------------------;\tgEFAGx[v
volume_software_enverope
 IFDEF	ES_DATA_TBL
		jsr	sound_data_add
		asl	a
		sta	ES_VALUE,x
		jmp	sound_data_read
 ENDIF
;---------------------------------------;F؂ւ
duty_change_2a03
		jsr	sound_data_add
		sta	A_TIMBRE,x
		lda	#$00
		sta	ED_VALUE,x
		jmp	sound_data_read
;---------------------------------------;f[eBGx[v
duty_enverope_2a03
 IFDEF	ED_DATA_TBL
		jsr	sound_data_add
		asl	a
		sta	ED_VALUE,x
		jmp	sound_data_read
 ENDIF
;---------------------------------------;x
rest_set
		ldx	<ZERO_CH
		lda	EFC_FLAG,x
		ora	#%01000000
		sta	EFC_FLAG,x
		jsr	sound_data_add
		sta	SND_COUNT,x

		cpx	#$04
		beq	.dpcm
		txa
		asl	a
		asl	a
		tay
		lda	#$00
		sta	$4000,y
		sta	$4002,y
		sta	$4003,y
		rts
.dpcm
		lda	#$0f
		sta	$4015
		rts
;---------------------------------------;n[hEFAXEB[v
hardware_sweep_2a03
		jsr	sound_data_add
		pha
		txa
		asl	a
		asl	a
		tay
		pla
		sta	$4001,y
		jmp	sound_data_read
;---------------------------------------;f`[
detune
		jsr	sound_data_add
		sta	DT_VALUE,x
		jmp	sound_data_read
;---------------------------------------;sb`Gx[v
pitch_enverope
 IFDEF	EP_DATA_TBL
		jsr	sound_data_add
		tay
		lda	EP_DELAY_TBL,y
		sta	EP_DELAY,x
		tya
		asl	a
		sta	EP_VALUE,x
		bcc	.end
		lda	EFC_FLAG,x
		ora	#%00010000
		sta	EFC_FLAG,x
		jmp	sound_data_read
.end
		lda	EFC_FLAG,x
		and	#%11101111
		sta	EFC_FLAG,x
		jmp	sound_data_read
 ENDIF
;---------------------------------------;m[gGx[v
note_enverope
 IFDEF	EN_DATA_TBL
		jsr	sound_data_add
		tay
		lda	EN_DELAY_TBL,y
		sta	EN_DELAY,x
		tya
		asl	a
		sta	EN_VALUE,x
		bcc	.end
		lda	EFC_FLAG,x
		ora	#%00100000
		sta	EFC_FLAG,x
		jmp	sound_data_read
.end
		lda	EFC_FLAG,x
		and	#%11011111
		sta	EFC_FLAG,x
		jmp	sound_data_read
 ENDIF
;---------------------------------------;NI^CY
quantize
 IFDEF	ES_DATA_TBL
		jsr	sound_data_add	;n/8ǂݍ
		sta	GATETIME,x
		lda	EFC_FLAG,x
		and	#%11111000
		ora	#%00000001
		sta	EFC_FLAG,x
		jmp	sound_data_read
 ENDIF
;---------------------------------------;NI^CYO
quantize_front
 IFDEF	ES_DATA_TBL
		jsr	sound_data_add
		sta	GATETIME,x
		lda	EFC_FLAG,x
		and	#%11111000
		ora	#%00000010
		sta	EFC_FLAG,x
		jmp	sound_data_read
 ENDIF
;---------------------------------------;NI^CY납
quantize_back
 IFDEF	ES_DATA_TBL
		jsr	sound_data_add
		sta	GATETIME,x
		lda	EFC_FLAG,x
		and	#%11111000
		ora	#%00000100
		sta	EFC_FLAG,x
		jmp	sound_data_read
 ENDIF
;---------------------------------------;NI^CYIt
quantize_off
 IFDEF	ES_DATA_TBL
		lda	EFC_FLAG,x
		and	#%11111000
		sta	EFC_FLAG,x
		jmp	sound_data_read
 ENDIF
;---------------------------------------;^C
tie
		jsr	sound_data_add
		sta	SND_COUNT,x
		rts
;---------------------------------------;X[
slur
		jmp	note_set_sub
;---------------------------------------;gڏ
frequncy_direct_write
		jsr	sound_data_add
		sta	SND_FREQ_L,x		;Low
		jsr	sound_data_add
		sta	SND_FREQ_H,x		;High
		jsr	sound_data_add
		sta	SND_COUNT,x			;Counter
		jmp	sound_effect_init
;---------------------------------------;[ڏ
memory_direct_write
		jsr	sound_data_add
		sta	<ZERO_02
		jsr	sound_data_add
		sta	<ZERO_03
		jsr	sound_data_add
		ldy	#$00
		sta	[ZERO_02],y
		jmp	sound_data_read
;---------------------------------------;
;---------------------------------------;
;---------------------------------------;gݒ
sound_freq_set
		lda	SND_NOTE,x		;vZς݂Ƃ
		cpx	#$03
		beq	.noise_frequency_get
		asl	a
		tay

		lda	PULSE_FREQ_TBL,y
		sta	SND_FREQ_L,x
		lda	PULSE_FREQ_TBL+1,y
		sta	SND_FREQ_H,x

		lda	DT_VALUE,x
		bne	.freq_detune_set
		rts
.freq_detune_set
		lda	DT_VALUE,x
		clc
		bmi	.freq_minus
		adc	SND_FREQ_L,x
		sta	SND_FREQ_L,x
		bcc	.return_00
		inc	SND_FREQ_H,x
.return_00
		rts
.freq_minus
		adc	SND_FREQ_L,x
		sta	SND_FREQ_L,x
		bcs	.return_01
		dec	SND_FREQ_H,x
.return_01
		rts

.noise_frequency_get
		tay
		lda	NOISE_FREQ_TBL,y
		sta	SND_FREQ_L,x
		rts
;---------------------------------------;WX^
sound_register_write
;		ldx	<ZERO_CH
		txa
		asl	a
		asl	a
		tay

		cpx	#$02
		bne	.relative_volume
		lda	A_VOLUME,x		;3chڂȂX[
		jmp	.through_01

.relative_volume
		lda	R_VOLUME,x		;Ήʏ
		clc
		bmi	.volume_minus
		adc	A_VOLUME,x		;{
		jmp	.through_00
.volume_minus
		adc	A_VOLUME,x		;|
		bpl	.through_00
		lda	#$00			;[艺ǂ
.through_00
		cmp	#$0f			;15ォǂ
		bmi	.through_01
		lda	#$0f
.through_01
		ora	A_TIMBRE,x
		sta	$4000,y
		lda	SND_FREQ_L,x
		sta	$4002,y
.reg4003_write
		lda	SND_FREQ_H,x
		cmp	REG4003X,x
		beq	.reg_write_end
		sta	$4003,y
		sta	REG4003X,x
.reg_write_end
		rts
;---------------------------------------;
 IFDEF	ES_DATA_TBL
ES_SOUND
		lda	ES_COUNT,x		;\tgGx̃JE^`FbN
		bne	.through_00
		lda	ES_ADD_L,x		;[
		sta	<ZERO_00
		lda	ES_ADD_H,x		;AhXf[^
		sta	<ZERO_01		;[y[WɎĂ
.data_read
		lda	[ZERO_00],y		;ʃf[^ǂݍ
		cmp	#$ff
		beq	.through_01
		cmp	#$fe
		beq	.sus_set
		sta	A_VOLUME,x		;ʏ

		jsr	sound_data_add
		sta	ES_COUNT,x		;JE^f[^
		inc	<ZERO_00
		bne	.through_02
		inc	<ZERO_01
.through_02
		lda	<ZERO_00
		sta	ES_ADD_L,x
		lda	<ZERO_01
		sta	ES_ADD_H,x		;AhX߂
.through_00
		dec	ES_COUNT,x		;炵
.through_01
		dec	GT_COUNT,x		;keyoffJE^炵
		bne	.return

		ldy	ES_VALUE,x
		lda	ER_DATA_TBL,y
		sta	ES_ADD_L,x
		lda	ER_DATA_TBL+1,y
		sta	ES_ADD_H,x		;[XGxZbg
		lda	#$00
		sta	ES_COUNT,x
.return
		rts				;I
.sus_set
		jsr	sound_data_add
		sta	<ZERO_02
		jsr	sound_data_add
		sta	<ZERO_01
		lda	<ZERO_02
		sta	<ZERO_00
		jmp	.data_read		;ǂ
 ENDIF
;---------------------------------------;
 IFDEF	ED_DATA_TBL
ED_SOUND
		lda	ED_ADD_L,x
		sta	<ZERO_00
		lda	ED_ADD_H,x
		sta	<ZERO_01
.data_read
		lda	[ZERO_00],y
		cmp	#$ff
		beq	.return
		cmp	#$fe
		beq	.repeat

		sta	A_TIMBRE,x
		inc	<ZERO_00
		bne	.through
		inc	<ZERO_01
.through
		lda	<ZERO_00
		sta	ED_ADD_L,x
		lda	<ZERO_01
		sta	ED_ADD_H,x
.return
		rts
.repeat
		jsr	sound_data_add		;f[eBGxɃR͕svȁH
		sta	<ZERO_02
		jsr	sound_data_add
		sta	<ZERO_01
		lda	<ZERO_02
		sta	<ZERO_00
		jmp	.data_read
 ENDIF
;---------------------------------------;
 IFDEF	EN_DATA_TBL
EN_SOUND
		lda	EN_COUNT,x
		bne	.return

		lda	EN_ADD_L,x
		sta	<ZERO_00
		lda	EN_ADD_H,x
		sta	<ZERO_01
.data_read
		lda	[ZERO_00],y
		cmp	#$80
		beq	.repeat

		clc
		adc	SND_NOTE,x
		sta	SND_NOTE,x
		jsr	sound_freq_set

		inc	<ZERO_00
		bne	.through
		inc	<ZERO_01
.through
		lda	<ZERO_00
		sta	EN_ADD_L,x
		lda	<ZERO_01
		sta	EN_ADD_H,x
		rts
.return
		dec	EN_COUNT,x
		rts
.repeat
		jsr	sound_data_add
		sta	<ZERO_02
		jsr	sound_data_add
		sta	<ZERO_01
		lda	<ZERO_02
		sta	<ZERO_00
		jmp	.data_read
		rts
 ENDIF
;---------------------------------------;
 IFDEF	EP_DATA_TBL
EP_SOUND
		lda	EP_COUNT,x
		bne	.return
		lda	EP_ADD_L,x
		sta	<ZERO_00
		lda	EP_ADD_H,x
		sta	<ZERO_01
.data_read

		lda	[ZERO_00],y
		bmi	.freq_minus
		clc
		adc	SND_FREQ_L,x
		sta	SND_FREQ_L,x
		bcc	.through_00
		inc	SND_FREQ_H,x
		jmp	.through_00
.freq_minus
		cmp	#$80
		beq	.repeat
		clc
		adc	SND_FREQ_L,x
		sta	SND_FREQ_L,x
		bcs	.through_00
		dec	SND_FREQ_H,x
.through_00

		inc	<ZERO_00
		bne	.through_01
		inc	<ZERO_01
.through_01

		lda	<ZERO_00
		sta	EP_ADD_L,x
		lda	<ZERO_01
		sta	EP_ADD_H,x
		rts
.return
		dec	EP_COUNT,x
		rts
.repeat
		jsr	sound_data_add
		sta	<ZERO_02
		jsr	sound_data_add
		sta	<ZERO_01
		lda	<ZERO_02
		sta	<ZERO_00
		jmp	.data_read
 ENDIF
;---------------------------------------;
sound_effect_init			;`AȂ̏dB
		lda	EFC_FLAG,x
		and	#%10111111
		sta	EFC_FLAG,x

 IFDEF	ES_DATA_TBL
		ldy	ES_VALUE,x
		beq	.jump_through
		lda	ES_DATA_TBL,y
		sta	ES_ADD_L,x
		lda	ES_DATA_TBL+1,y
		sta	ES_ADD_H,x

		lda	#$00
		sta	ES_COUNT,x

		lda	EFC_FLAG,x
		and	#%00000111
		beq	.quantize8
		lsr	a
		bcs	.quantize
		lsr	a
		bcs	.quantize_front

		lda	SND_COUNT,x	;NI^CYobN
		sec
		sbc	GATETIME,x
		sta	GT_COUNT,x
.jump_through
		jmp	.through_00
.quantize_front
		lda	GATETIME,x	;NI^CYtg
		sta	GT_COUNT,x
		jmp	.through_00
.quantize8
		lda	#$ff
		sta	GT_COUNT,x
		jmp	.through_00
.quantize
		lda	#$00		; Œ菬()
		sta	<ZERO_02
		lda	SND_COUNT,x	; 
		sta	<ZERO_03	; Œ菬()

		lda	#$00
		sta	<ZERO_04	; vZꂽ
		sta	<ZERO_05	; vZꂽ
.quantize_div2
		lsr	<ZERO_03	; 1/2
		ror	<ZERO_02

		lda	GATETIME,x	; NI^CY(0-7܂ŁB8͓ʈĸ)
		and	#%00000100	; 1/2Kv́H
		beq	.quantize_div4	; ˂

		lda	<ZERO_02	; ŏRs[OK
		sta	<ZERO_04
		lda	<ZERO_03
		sta	<ZERO_05
.quantize_div4
		lsr	<ZERO_03	; 1/4
		ror	<ZERO_02

		lda	GATETIME,x
		and	#%00000010	; 1/4Kv́H
		beq	.quantize_div8	; ˂

;;;		clc			; ZERO_02EVtgc0vȂ
		lda	<ZERO_02
		adc	<ZERO_04
		sta	<ZERO_04
		lda	<ZERO_03
		adc	<ZERO_05
		sta	<ZERO_05
.quantize_div8
		lsr	<ZERO_03		; 1/8
		ror	<ZERO_02

		lda	GATETIME,x
		and	#%00000001	; 1/8Kv́H
		beq	.quantize_div16	; ˂

;;;		clc			; <ZERO_02EVtgc0vȂ
		lda	<ZERO_02
		adc	<ZERO_04
		sta	<ZERO_04
		lda	<ZERO_03
		adc	<ZERO_05
		sta	<ZERO_05
.quantize_div16
		lda	<ZERO_05
		sta	GT_COUNT,x
.through_00
 ENDIF

 IFDEF	ED_DATA_TBL
		ldy	ED_VALUE,x
		beq	.through_01
		lda	ED_DATA_TBL,y
		sta	ED_ADD_L,x
		lda	ED_DATA_TBL+1,y
		sta	ED_ADD_H,x
.through_01
 ENDIF

 IFDEF	EP_DATA_TBL
		ldy	EP_VALUE,x
		beq	.through_02
		lda	EP_DATA_TBL,y
		sta	EP_ADD_L,x
		lda	EP_DATA_TBL+1,y
		sta	EP_ADD_H,x
		lda	EP_DELAY,x
		sta	EP_COUNT,x
		lda	EFC_FLAG,x
		and	#%00010000
		beq	.through_02
		lda	GT_COUNT,x
		sta	EP_COUNT,x
.through_02
 ENDIF

 IFDEF	EN_DATA_TBL
		ldy	EN_VALUE,x
		beq	.through_03
		lda	EN_DATA_TBL,y
		sta	EN_ADD_L,x
		lda	EN_DATA_TBL+1,y
		sta	EN_ADD_H,x
		lda	EN_DELAY,x
		sta	EN_COUNT,x
		lda	EFC_FLAG,x
		and	#%00100000
		beq	.through_03
		lda	GT_COUNT,x
		sta	EN_COUNT,x
.through_03
 ENDIF
		rts
;---------------------------------------;
PULSE_FREQ_TBL
		dw	$87F2,$877F,$8713			;o1          A ,A+,B
		dw	$86AE,$864E,$85F3,$859E,$854D,$8501	;o2 C ,C+,D ,D+,E ,F
		dw	$84B9,$8475,$8435,$83F8,$83BF,$8389	;   F+,G ,G+,A ,A+,B
		dw	$8357,$8327,$82F9,$82CF,$82A6,$8280	;o3
		dw	$825C,$823A,$821A,$81FC,$81DF,$81C4	;
		dw	$81AB,$8193,$817C,$8167,$8153,$8140	;o4
		dw	$812E,$811D,$810D,$80FE,$80EF,$80E2	;
		dw	$80D5,$80C9,$80BE,$80B3,$80A9,$809F	;o5
		dw	$8096,$808D,$8085,$807E,$8076,$8070	;
		dw	$8069,$8063,$805E,$8058,$8053,$804F	;o6
		dw	$804A,$8046,$8042,$803E,$803A,$8037	;̕ӂ͉sȂ񂶂I
;-------------------------------------------------------;
;ڂ
;
;pXgĐg = 1.7897725MHz / ((n+1)*16)@ŎZo
;gpf[^11bit(0000h-07ffh)ō\邽߁A
;0800hȏ̉͏o܂B](07F2h)o1 a艺̉͏o܂
;XɓƂ
;0007hȉ̉͏o܂B](0008h)o9f+̉͏o܂
;
;Opg̓pXgƓf[^^ƍXɂPIN^[uႢo܂
;]āAo0a艺Eo8f+̉͏o܂
;OpgĐg = 1.7897725MHz / ((n+1)*32)@ŎZo
;
;-------------------------------------------------------;
NOISE_FREQ_TBL
		db	$00,$01,$02,$03,$04,$05,$06,$07	;32kbit[h
		db	$08,$09,$0A,$0B,$0C,$0D,$0E,$0F	;o0c`o1d+

		db	$80,$81,$82,$83,$84,$85,$86,$87	;93bit[h
		db	$88,$89,$8A,$8B,$8C,$8D,$8E,$8F	;o1e`o2g
;-------------------------------------------------------;
;ڂ
;
;ȉ߈Dihttp://www.lv1.net/ns/index.htmljp
;̃^Cv32kbit[h93bit[hA$400Ebit7Ŏw
;bit7ÔƂ32kbit[hɂȂA1̂Ƃ93bit(ɌZmCY)[hƂȂ
;mCY`l̍Đg$400Ebit3-0Ŏw肷
;̒l11bit̐ɕϊAg1.79MHz / 11bitl
;
;	bit3-0 	11bitl	(IN^[u) 
;	0	002	A(15)
;	1	004	A(14)
;	2	008	A(13)
;	3	010	A(12)
;	4	020	A(11)
;	5	030	D(11)
;	6	040	A(10)
;	7	050	F(10)
;	8	065	C(10)
;	9	07F	A( 9)
;	A	0BE	D( 9)
;	B	0FE	A( 8)
;	C	17D	D( 8)
;	D	1FC	A( 7)
;	E	3F9	A( 6)
;	F	7F2	A( 5)
;
;-------------------------------------------------------;

;+------ channel on/off flag
;l+----- rest flag
;ll+---- note enverope gatetime flag
;lll+--- pitch enverope gatetime flag
;llll+---- 
;lllll+--- quantize back flag
;llllll+-- quantize front flag
;lllllll+- quantize flag
;llllllll
;crnpxqqq

ZERO_00		=$00		;[y[W
ZERO_01		=$01		;̃hCołpȂ
ZERO_02		=$02		;Rɗp\
ZERO_03		=$03
ZERO_04		=$04
ZERO_05		=$05		;AE\
ZERO_CH		=$06		;ꂾ̓hCoOɃ[ƂȂƃ_

R_VOLUME	=$0500

SND_ADD_L	=$0600
SND_ADD_H	=$0610
SND_NOTE	=$0620
SND_COUNT	=$0710
EFC_FLAG	=$0640
DT_VALUE	=$0650
SND_FREQ_L	=$0660
SND_FREQ_H	=$0670
A_VOLUME	=$0680
A_TIMBRE	=$0690
REG4003X	=$06a0

ES_VALUE	=$06b0	;keyoffL
ES_ADD_L	=$06c0	;keyoffL
ES_ADD_H	=$06d0	;keyoffL
ES_COUNT	=$06e0	;keyoffL
GATETIME	=$06f0
GT_COUNT	=$0700

ED_VALUE	=$0630
ED_ADD_L	=$0720
ED_ADD_H	=$0730

EP_VALUE	=$0740
EP_DELAY	=$0750
EP_COUNT	=$0760
EP_ADD_L	=$0770
EP_ADD_H	=$0780

EN_VALUE	=$0790
EN_DELAY	=$07a0
EN_COUNT	=$07b0
EN_ADD_L	=$07c0
EN_ADD_H	=$07d0

RT_ADD_L	=$07e0
RT_ADD_H	=$07f0


	IF (SOUND_GENERATOR = %00000001)
	include	"vrc6.asm"
	ENDIF
	IF (SOUND_GENERATOR = %00000100)
	include	"fds.asm"
	ENDIF
	IF (SOUND_GENERATOR = %00010000)
	include	"n106.asm"
	ENDIF

	db	"version 0.62beta"
