;---------------------------------------------------
ex_apu_freq
		cpx	#$07
		beq	.saw_note_set
.note_set
		sec
		sbc	#$09
		sta	SND_NOTE,x
		jsr	sound_data_add
		sta	SND_COUNT,x
		lda	SND_NOTE,x
		asl	a
		tay
		lda	SQU_FREQ_TBL,y
		sta	SND_FREQ_L,x
		lda	SQU_FREQ_TBL+1,y
		sta	SND_FREQ_H,x
		lda	DT_VALUE,x
		bne	.freq_detune_set
		jmp	sound_effect_init
.freq_detune_set
		lda	DT_VALUE,x
		clc
		bmi	.freq_minus
		adc	SND_FREQ_L,x
		sta	SND_FREQ_L,x
		bcc	.return
		inc	SND_FREQ_H,x
		bne	.return
.freq_minus
		adc	SND_FREQ_L,x
		sta	SND_FREQ_L,x
		bcs	.return
		dec	SND_FREQ_H,x
.return
		jmp	sound_effect_init

.saw_note_set
		sec
		sbc	#$0c
		sta	SND_NOTE,x
		jsr	sound_data_add
		sta	SND_COUNT,x
		lda	SND_NOTE,x
		asl	a
		tay
		lda	SAW_FREQ_TBL,y
		sta	SND_FREQ_L,x
		lda	SAW_FREQ_TBL+1,y
		sta	SND_FREQ_H,x
		lda	DT_VALUE,x
		bne	.freq_detune_set
		jmp	sound_effect_init
;---------------------------------------------------
ex_apu_reg
		lda	R_VOLUME,x
		clc
		bmi	.volume_minus
		adc	A_VOLUME,x
		jmp	.through_00
.volume_minus
		adc	A_VOLUME,x
		sta	A_VOLUME,x
		bpl	.through_00
		lda	#$00
.through_00

		cpx	#$06
		beq	.regA000
		cpx	#$07
		beq	.regB000
.reg9000
		cmp	#$0f
		bmi	.through_01
		lda	#$0f
.through_01
		ora	A_TIMBRE,x
		sta	$9000
		lda	SND_FREQ_L,x
		sta	$9001
		lda	SND_FREQ_H,x
		sta	$9002
		rts
.regA000
		cmp	#$0f
		bmi	.through_02
		lda	#$0f
.through_02
		ora	A_TIMBRE,x
		sta	$a000
		lda	SND_FREQ_L,x
		sta	$a001
		lda	SND_FREQ_H,x
		sta	$a002
		rts
.regB000
		cmp	#$3f
		bmi	.through_03
		lda	#$3f
.through_03
		ora	A_TIMBRE,x
		sta	$b000
		lda	SND_FREQ_L,x
		sta	$b001
		lda	SND_FREQ_H,x
		sta	$b002
		rts
;---------------------------------------------------
;Pulse1,2
;Freq = 1.7897725MHz / ((n+1)*16)	;2A03ƑSł
;Saw
;Freq = 1.7897725MHz / ((n+1)*14)
;--------------------------------------------------
SQU_FREQ_TBL
	dw	$8FE4,$8EFE,$8E26			;o0 a a+ b
	dw	$8D5C,$8C9C,$8BE8,$8B3C,$8A9C,$8A02	;o1
	dw	$8972,$88EC,$886C,$87F2,$877F,$8713
	dw	$86AE,$864E,$85F4,$859E,$854E,$8501	;o2
	dw	$84B9,$8476,$8436,$83F9,$83C0,$838A
	dw	$8357,$8327,$82FA,$82CF,$82A7,$8281	;o3
	dw	$825D,$823B,$821B,$81FD,$81E0,$81C5
	dw	$81AB,$8193,$817C,$8167,$8153,$8140	;o4
	dw	$812E,$811D,$810D,$80FE,$80EF,$80E2
	dw	$80D5,$80C9,$80BE,$80B3,$80A9,$809F	;o5
	dw	$8096,$808D,$8085,$807E,$8076,$8070
	dw	$8069,$8063,$805E,$8058,$8053,$804F	;o6
	dw	$804A,$8046,$8042,$803E,$803A,$8037

SAW_FREQ_TBL
	dw	$8F44,$8E68,$8D9A,$8CD6,$8C1E,$8D76	;o1
	dw	$8ACC,$8A30,$89A4,$8914,$8890,$8816
	dw	$87A2,$8734,$86CD,$866B,$860F,$86B8	;o2 ?
	dw	$8566,$8518,$84D2,$848A,$8448,$840B
	dw	$83D1,$839A,$8366,$8335,$8307,$82DC	;o3 ?
	dw	$82B3,$828C,$8269,$8245,$8224,$8205
	dw	$81EB,$81CD,$81B3,$819A,$8183,$816E	;o4
	dw	$8159,$8146,$8134,$8122,$8112,$8102
	dw	$80F5,$80E6,$80D9,$80CD,$80C1,$80B7	;o5
	dw	$80AC,$80A3,$809A,$8091,$8089,$8081
	dw	$807A,$8073,$806C,$8066,$8060,$805B	;o6
	dw	$8056,$8051,$804D,$8048,$8044,$8040
;-------------------------------------------------
